# std::money_get< _CharT, _InIter > Class Template Reference

Inheritance diagram for std::money_get< _CharT, _InIter >:

List of all members.

## Detailed Description

### template<typename _CharT, typename _InIter>
class std::money_get< _CharT, _InIter >

This facet encapsulates the code to parse and return a monetary amount from a string.

The money_get template uses protected virtual functions to provide the actual results. The public accessors forward the call to the virtual functions. These virtual functions are hooks for developers to implement the behavior they require from the money_get facet.

Definition at line 4045 of file locale_facets.h.

## Public Types

- typedef _CharT char_type
- typedef _InIter iter_type
- typedef basic_string< _CharT > string_type

## Public Member Functions

- iter_type get (iter_type __s, iter_type __end, bool __intl, ios_base &__io, ios_base::iostate &__err, string_type &__digits) const
- iter_type get (iter_type __s, iter_type __end, bool __intl, ios_base &__io, ios_base::iostate &__err, long double &__units) const
- money_get (size_t __refs=0)

## Static Public Attributes

- static locale::id id

## Protected Member Functions

- template<bool _Intl> iter_type _M_extract (iter_type __s, iter_type __end, ios_base &__io, ios_base::iostate &__err, string &__digits) const
- virtual iter_type do_get (iter_type __s, iter_type __end, bool __intl, ios_base &__io, ios_base::iostate &__err, string_type &__digits) const
- virtual iter_type do_get (iter_type __s, iter_type __end, bool __intl, ios_base &__io, ios_base::iostate &__err, long double &__units) const
- virtual ~money_get ()

## Static Protected Member Functions

- static __c_locale _S_clone_c_locale (__c_locale &__cloc)
- static void _S_create_c_locale (__c_locale &__cloc, const char *__s, __c_locale __old=0)
- static void _S_destroy_c_locale (__c_locale &__cloc)
- static __c_locale _S_get_c_locale ()
- static const char * _S_get_c_name ()

## Friends

- class locale::_Impl

## Member Typedef Documentation

template<typename _CharT, typename _InIter>

typedef _CharT std::money_get< _CharT, _InIter >::char_type

Public typedefs.

Definition at line 4051 of file locale_facets.h.

template<typename _CharT, typename _InIter>

typedef _InIter std::money_get< _CharT, _InIter >::iter_type

Public typedefs.

Definition at line 4052 of file locale_facets.h.

template<typename _CharT, typename _InIter>

typedef basic_string<_CharT> std::money_get< _CharT, _InIter >::string_type

Public typedefs.

Definition at line 4053 of file locale_facets.h.

## Constructor & Destructor Documentation

template<typename _CharT, typename _InIter>

std::money_get< _CharT, _InIter >::money_get | ( | size_t | __refs = `0` | ) | `[inline, explicit]`

Constructor performs initialization.

This is the constructor provided by the standard.

Parameters:

  | refs | Passed to the base facet class.

Definition at line 4067 of file locale_facets.h.

template<typename _CharT, typename _InIter>

virtual std::money_get< _CharT, _InIter >::~money_get | ( |  | ) | `[inline, protected, virtual]`

Destructor.

Definition at line 4134 of file locale_facets.h.

## Member Function Documentation

template<typename _CharT, typename _InIter>

_InIter std::money_get< _CharT, _InIter >::do_get | ( | iter_type | __s,
|  | iter_type | __end,
|  | bool | __intl,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | string_type & | __digits |
| ) |  |  | const`[protected, virtual]`

Read and parse a monetary value.

This function reads and parses characters representing a monetary value. This function is a hook for derived classes to change the value returned.

See also:
  get() for details.

Definition at line 1563 of file locale_facets.tcc.

References std::ios_base::_M_getloc(), std::basic_string< _CharT, _Traits, _Alloc >::resize(), and std::__ctype_abstract_base< _CharT >::widen().

template<typename _CharT, typename _InIter>

_InIter std::money_get< _CharT, _InIter >::do_get | ( | iter_type | __s,
|  | iter_type | __end,
|  | bool | __intl,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | long double & | __units |
| ) |  |  | const`[protected, virtual]`

Read and parse a monetary value.

This function reads and parses characters representing a monetary value. This function is a hook for derived classes to change the value returned.

See also:
  get() for details.

Definition at line 1550 of file locale_facets.tcc.

References std::basic_string< _CharT, _Traits, _Alloc >::c_str().

Referenced by std::money_get< _CharT, _InIter >::get().

template<typename _CharT, typename _InIter>

iter_type std::money_get< _CharT, _InIter >::get | ( | iter_type | __s,
|  | iter_type | __end,
|  | bool | __intl,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | string_type & | __digits |
| ) |  |  | const`[inline]`

Read and parse a monetary value.

This function reads characters from s, interprets them as a monetary value according to moneypunct and ctype facets retrieved from io.getloc(), and returns the result in digits. For example, the string $10.01 in a US locale would store "1001" in digits.

Any characters not part of a valid money amount are not consumed.

If a money value cannot be parsed from the input stream, sets err=(err|io.failbit). If the stream is consumed before finishing parsing, sets err=(err|io.failbit|io.eofbit).

This function works by returning the result of do_get().

Parameters:

  | s | Start of characters to parse.
  | end | End of characters to parse.
  | intl | Parameter to use_facet<moneypunct<CharT,intl> >.
  | io | Source of facets and io state.
  | err | Error field to set if parsing fails.
  | digits | Place to store result of parsing.

Returns:
  Iterator referencing first character beyond valid money amount.

Definition at line 4127 of file locale_facets.h.

References std::money_get< _CharT, _InIter >::do_get().

template<typename _CharT, typename _InIter>

iter_type std::money_get< _CharT, _InIter >::get | ( | iter_type | __s,
|  | iter_type | __end,
|  | bool | __intl,
|  | ios_base & | __io,
|  | ios_base::iostate & | __err,
|  | long double & | __units |
| ) |  |  | const`[inline]`

Read and parse a monetary value.

This function reads characters from s, interprets them as a monetary value according to moneypunct and ctype facets retrieved from io.getloc(), and returns the result in units as an integral value moneypunct::frac_digits() * the actual amount. For example, the string $10.01 in a US locale would store 1001 in units.

Any characters not part of a valid money amount are not consumed.

If a money value cannot be parsed from the input stream, sets err=(err|io.failbit). If the stream is consumed before finishing parsing, sets err=(err|io.failbit|io.eofbit). units is unchanged if parsing fails.

This function works by returning the result of do_get().

Parameters:

  | s | Start of characters to parse.
  | end | End of characters to parse.
  | intl | Parameter to use_facet<moneypunct<CharT,intl> >.
  | io | Source of facets and io state.
  | err | Error field to set if parsing fails.
  | units | Place to store result of parsing.

Returns:
  Iterator referencing first character beyond valid money amount.

Definition at line 4097 of file locale_facets.h.

References std::money_get< _CharT, _InIter >::do_get().

## Member Data Documentation

template<typename _CharT, typename _InIter>

locale::id std::money_get< _CharT, _InIter >::id`[static]`

Numpunct facet id.

Definition at line 4057 of file locale_facets.h.

The documentation for this class was generated from the following files:

- locale_facets.h
- locale_facets.tcc